var search_data = {"index":{"searchIndex":["array","hash","integer","kernel","module","object","string","^()","cmpi()","d()","display()","extract()","fn()","has_shape?()","in_groups_of()","private_accessor()","prompt()","random_subarray()","reductions()","require_optional()","string_length()","to_ostruct()","with()","zip_with()"],"longSearchIndex":["array","hash","integer","kernel","module","object","string","array#^()","string#cmpi()","object#d()","object#display()","hash#extract()","kernel#fn()","hash#has_shape?()","string#in_groups_of()","module#private_accessor()","kernel#prompt()","array#random_subarray()","array#reductions()","kernel#require_optional()","integer#string_length()","hash#to_ostruct()","kernel#with()","array#zip_with()"],"info":[["Array","","Array.html","",""],["Hash","","Hash.html","",""],["Integer","","Integer.html","",""],["Kernel","","Kernel.html","",""],["Module","","Module.html","",""],["Object","","Object.html","",""],["String","","String.html","",""],["^","Array","Array.html#method-i-5E","(other)","<p>Returns an array containing elements exclusive between two arrays.\n<p>@example\n\n<pre class=\"ruby\">[<span class=\"ruby-value\">1</span>, <span class=\"ruby-value\">2</span>, <span class=\"ruby-value\">3</span>] <span class=\"ruby-operator\">^</span> [<span class=\"ruby-value\">1</span>, <span class=\"ruby-value\">2</span>, <span class=\"ruby-value\">4</span>] <span class=\"ruby-comment\">#=&gt; [3, ...</span>\n</pre>\n"],["cmpi","String","String.html#method-i-cmpi","(other)","<p>Compares strings ignoring case\n<p>@example\n\n<pre class=\"ruby\"><span class=\"ruby-string\">&quot;test&quot;</span>.<span class=\"ruby-identifier\">cmpi</span>(<span class=\"ruby-string\">&quot;tesT&quot;</span>) <span class=\"ruby-comment\">#=&gt; true</span>\n</pre>\n"],["d","Object","Object.html#method-i-d","(new_line = true)",""],["display","Object","Object.html#method-i-display","(new_line = true)","<p>Outputs the object and also returns it. Will use <code>puts</code> if <code>new_line</code> is <code>true</code> and <code>print</code> otherwise.\n<p>@example …\n"],["extract","Hash","Hash.html#method-i-extract","(*ks)","<p>Returns a new hash only with the specified keys (if present).\n<p>@example Key order does not matter\n\n<pre>hash = ...</pre>\n"],["fn","Kernel","Kernel.html#method-i-fn","(*funs)","<p>Composes a list of functions. Functions can be specified as symbols or lambdas.\n<p>@example Composing symbols …\n"],["has_shape?","Hash","Hash.html#method-i-has_shape-3F","(shape)","<p>Checks if a hash has a certain structure.\n<p>@example Simple hash\n\n<pre>h = { k1: 1, k2: &quot;1&quot; }\nh.has_shape?(k1: ...</pre>\n"],["in_groups_of","String","String.html#method-i-in_groups_of","(size)","<p>Returns an array of the string broken down into groups of <code>size</code> characters.\n\n<pre class=\"ruby\"><span class=\"ruby-string\">&quot;aabbcc&quot;</span>.<span class=\"ruby-identifier\">in_groups_of</span>(<span class=\"ruby-value\">2</span>) <span class=\"ruby-comment\">#=&gt; ...</span>\n</pre>\n"],["private_accessor","Module","Module.html#method-i-private_accessor","(*names)","<p>Works like <code>attr_accessor</code> but generates private getter/setter methods for class internal use only. Useful …\n"],["prompt","Kernel","Kernel.html#method-i-prompt","(text = \"\", conversion = nil)","<p>Displays a prompt and returns chomped input. Modelled after the Python method <code>raw_input</code>, but also can …\n"],["random_subarray","Array","Array.html#method-i-random_subarray","(n = 1)","<p>Generates random subarrays. Uses random numbers and bit-fiddling to assure performant uniform distributions …\n"],["reductions","Array","Array.html#method-i-reductions","(*args, &block)","<p>Similar to <code>reduce</code>/<code>inject</code>, but also returns intermediate values. Has the  same interface as <code>reduce</code>/<code>inject</code> …\n"],["require_optional","Kernel","Kernel.html#method-i-require_optional","(gem, &block)","<p>Optionally require a gem. If it is not available, <code>nil</code> will be returned. Alternatively, a block can be …\n"],["string_length","Integer","Integer.html#method-i-string_length","()","<p>Returns the length of the number&#39;s string representation. @example\n\n<pre class=\"ruby\"><span class=\"ruby-value\">0</span>.<span class=\"ruby-identifier\">string_length</span> <span class=\"ruby-comment\">#=&gt; 1</span>\n<span class=\"ruby-value\">123</span>.<span class=\"ruby-identifier\">string_length</span> <span class=\"ruby-operator\">...</span>\n</pre>\n"],["to_ostruct","Hash","Hash.html#method-i-to_ostruct","()","<p>Recursively converts a <code>Hash</code> and all nested <code>Hash</code>es to <code>OpenStruct</code>s. Especially useful for parsing YAML …\n"],["with","Kernel","Kernel.html#method-i-with","(o, &blk)","<p>A Pascal/ActionScript like <code>with</code> method. Yields its argument to the provided block and then returns it. …\n"],["zip_with","Array","Array.html#method-i-zip_with","(other, op = nil)","<p>Zip <code>self</code> with <code>other</code>, combining the elements with the provided block or symbol. The resulting array will …\n"]]}}